
\begin{tt}
\begin{verbatim}

module declad_eg72.

export p(bf).

% Even if only one answer is desired, the following aggregate selection 
% could lead to some answers not being computed.  For example, with
% ?p(1,X), the facts p(2,4) and p(4,5) are needed to compute p(1,5),
% which is the only answer.  However, CORAL will (non-deterministically)
% retain only one of the facts p(2,3) and p(2,4); if it retains $p(2,3)$,
% as it does in the current implementation, the answer is not generated.

%@aggregate_selection p(X,Y) (X) any(Y).

p(X,Y) :- b(X,Y).
p(X,W) :- c(X,U), p(U,V), p(V,W).

end_module.

c(1,2).
b(2,3).
b(2,4).
b(4,5).

\end{verbatim}
\end{tt}

