
\begin{tt}
\begin{verbatim}

module pipe_eg12.
@pipelining.

export multiset_to_list(bf).

% The first argument must be bound to a list; returns a multiset
% with the same elements.

multiset_to_list(S, L) :- 
                    % ensures no dup chks on base relations
	clear(check_subsumption),
                    % notice the use of member in pipelined module
	member(S, X), insert(temp(X)),
        % should turn on subsumption checks again here if desired.
	convert(temp, [], L).

convert(R, Lin, Lout) :- 
                % The CORAL parser doesn't accept variables in
		% places where it expects a constant;
		% hence this kludge
	univ(T, [R,X]),
	call(T),	% T= R(X); X is bound by this call
	delete(T),
	convert(R, [X|Lin], Lout).

convert(_, L, L).

end_module.

\end{verbatim}
\end{tt}

